//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrLimeGreen  
#property indicator_color2  clrDimGray
#property indicator_color3  clrOrange
#property indicator_color4  clrSilver
#property indicator_color5  clrLimeGreen
#property indicator_color6  clrLimeGreen
#property indicator_color7  clrOrange
#property indicator_color8  clrOrange
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

enum enColorTypes
{
   cltZeroCross, // Color change on zero cross
   cltLevelCross // Color change on outer levels cross
};
extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                MomPeriod       =  32;
extern ENUM_APPLIED_PRICE MomPrice        = PRICE_CLOSE;
extern int                MinMaxPeriod    = 100;
extern double             LevelUp         =  80;
extern double             LevelDown       =  20;
extern enColorTypes       ColorChangeWhen = cltLevelCross;
extern bool               alertsOn        = false;         // Turn alerts on
extern bool               alertsOnCurrent = true;          // Alerts on still opened bar
extern bool               alertsMessage   = true;          // Alerts should show popup message
extern bool               alertsSound     = false;         // Alerts should play a sound
extern bool               alertsEmail     = false;         // Alerts should send email
extern bool               alertsPushNotif = false;         // Alerts should send notification
extern bool               Interpolate     = true;

//
//
//
//
//

double momMin[];
double momMax[];
double momLUp[];
double momLMi[];
double momLDn[];
double mom[];
double momUa[];
double momUb[];
double momDa[];
double momDb[];
double colors[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,momLUp);
   SetIndexBuffer(1,momLMi);
   SetIndexBuffer(2,momLDn);
   SetIndexBuffer(3,mom);
   SetIndexBuffer(4,momUa);
   SetIndexBuffer(5,momUb);
   SetIndexBuffer(6,momDa);
   SetIndexBuffer(7,momDb);
   SetIndexBuffer(8,momMin);
   SetIndexBuffer(9,momMax);
   SetIndexBuffer(10,colors);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
   
      IndicatorShortName(timeFrameToString(TimeFrame)+" velocity fl ("+MomPeriod+","+DoubleToStr(LevelDown,2)+","+DoubleToStr(LevelUp,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { momLUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      if (colors[limit] ==-1) CleanPoint(limit,momDa,momDb);
      if (colors[limit] == 1) CleanPoint(limit,momUa,momUb);
      for(i=limit; i>=0; i--) 
      {
         double atr = iATR(NULL,0,MomPeriod,i);
         if (atr!=0)
               mom[i] = iMomentumS(iMA(NULL,0,1,0,MODE_SMA,MomPrice,i),MomPeriod,1,2,i)/atr;
         else  mom[i] = 0;
         momMin[i] = mom[ArrayMinimum(mom,MinMaxPeriod,i)];
         momMax[i] = mom[ArrayMaximum(mom,MinMaxPeriod,i)];
         momDa[i]  = EMPTY_VALUE;
         momDb[i]  = EMPTY_VALUE;
         momUa[i]  = EMPTY_VALUE;
         momUb[i]  = EMPTY_VALUE;
            double range = momMax[i]-momMin[i];
               momLDn[i] = momMin[i]+range*LevelDown/100.0;
               momLMi[i] = momMin[i]+range*0.5;
               momLUp[i] = momMin[i]+range*LevelUp/100.0;
               colors[i] = colors[i+1];
               if (ColorChangeWhen==cltZeroCross)
               {
                  if (mom[i]>momLMi[i]) colors[i] =  1;
                  if (mom[i]<momLMi[i]) colors[i] = -1;
               }
               else
               {
                  colors[i] = 0;
                  if (mom[i]>momLUp[i]) colors[i] =  1;
                  if (mom[i]<momLDn[i]) colors[i] = -1;
               }
               if (colors[i] ==  1) PlotPoint(i,momUa,momUb,mom);
               if (colors[i] == -1) PlotPoint(i,momDa,momDb,mom);
      }      
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (colors[whichBar] != colors[whichBar+1])
      {
         if (colors[whichBar] == 1) doAlert("up");
         if (colors[whichBar] ==-1) doAlert("down");       
      }         
   }   
      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (colors[limit] ==-1) CleanPoint(limit,momDa,momDb);
   if (colors[limit] == 1) CleanPoint(limit,momUa,momUb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         momLUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif, 0,y);
         momLMi[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif, 1,y);
         momLDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif, 2,y);
         mom   [i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif, 3,y);
         colors[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif,10,y);
         momDa[i]  = EMPTY_VALUE;
         momDb[i]  = EMPTY_VALUE;
         momUa[i]  = EMPTY_VALUE;
         momUb[i]  = EMPTY_VALUE;
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               momLUp[i+k] = momLUp[i] + (momLUp[i+n] - momLUp[i])*k/n;
               momLMi[i+k] = momLMi[i] + (momLMi[i+n] - momLMi[i])*k/n;
               momLDn[i+k] = momLDn[i] + (momLDn[i+n] - momLDn[i])*k/n;
               mom[i+k]    = mom[i]    + (mom[i+n]    - mom[i]   )*k/n;
            }
   }
   for(i=limit; i>=0; i--)
   {
      if (colors[i] ==  1) PlotPoint(i,momUa,momUb,mom);
      if (colors[i] == -1) PlotPoint(i,momDa,momDb,mom);
   }      
   Comment(colors[0]);
   return(0);
         
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" velocity floating levels changed state to "+doWhat;
             if (alertsMessage)   Alert(message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol()," velocity floating levels "),message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}
//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workMom[];
double iMomentumS(double price, double length, double powSlow, double powFast, int i)
{
   if (ArraySize(workMom)!=Bars) ArrayResize(workMom,Bars);
      i = Bars-i-1; workMom[i] = price;
      
      //
      //
      //
      //
      //
      
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;
         for(int k=0; k<length; k++)
         {
            double weight = length-k;
               suma  += workMom[i-k] * MathPow(weight,powSlow);
               sumb  += workMom[i-k] * MathPow(weight,powFast);
               sumwa += MathPow(weight,powSlow);
               sumwb += MathPow(weight,powFast);
         }
   return(sumb/sumwb-suma/sumwa);
}  


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}